## mingw-w64-tmxlite-1.4.4-1.src.tar.zst

=== meson_options.txt ===
option('use_rtti', type: 'boolean', value: true, description: 'Use run time type information?', yield: true)
option('project_static_runtime', type: 'boolean', value: false, description: 'Use statically linked standard/runtime libraries?', yield: true)
option('use_extlibs', type: 'boolean', value: false, description: 'Use external pugixml, zstd and zlib libraries instead of the included source?', yield: true)
option('use_zstd', type: 'boolean', value: false, description: 'Use zstd compression library (automatically enabled when use_extlibs is true)?', yield: true)
option('build_examples', type: 'boolean', value: false)
option('build_tests', type: 'boolean', value: false)
option('pause_test', type: 'boolean', value: true, description: 'Wait for user input after tests have finished running')
