=== OpenGLExample/src/CMakeLists.txt ===
set(PROJECT_SRC
  ${PROJECT_DIR}/Game.cpp
  ${PROJECT_DIR}/main.cpp
  ${PROJECT_DIR}/MapLayer.cpp
  ${PROJECT_DIR}/OpenGL.cpp)
