=== tmxlite/src/CMakeLists.txt ===
set(PROJECT_SRC
  ${PROJECT_DIR}/FreeFuncs.cpp
  ${PROJECT_DIR}/ImageLayer.cpp
  ${PROJECT_DIR}/Map.cpp
  ${PROJECT_DIR}/Object.cpp
  ${PROJECT_DIR}/ObjectGroup.cpp
  ${PROJECT_DIR}/Property.cpp
  ${PROJECT_DIR}/TileLayer.cpp
  ${PROJECT_DIR}/LayerGroup.cpp
  ${PROJECT_DIR}/Tileset.cpp
  ${PROJECT_DIR}/ObjectTypes.cpp)
  
  set(LIB_SRC
    ${PROJECT_DIR}/miniz.c
    ${PROJECT_DIR}/detail/pugixml.cpp)
